
var LruMap = require("collections/lru-map");
var WeakMap = require("collections/weak-map");
var adapt = require("./adapt");

module.exports = Connection;
function Connection(connection, local, options) {

    options = options || new Options(options);
    var objectToId = WeakMap();
    var idToObject = LruMap(null, options.max);

    connection = adapt(connection);

    function got(message) {
        getNext();
        if (!receivers[message.type])
            return;
        if (!locals.has(message.to))
            return;
    }
    function getNext() {
        connection.get().then(got).done();
    }
    getNext();

}

function Options(options) {
    this.max = options.max || Infinity;
}

